'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (babel) {
  return {
    visitor: {
      CallExpression: function CallExpression(path, state) {
        var callee = path.get('callee');
        if (callee && callee.matchesPattern('System.import')) {
          var params = path.get('arguments');
          if (params.length && params[0].isLiteral()) {
            (0, _babelArgumentProvider.setBabelArgument)(babel);
            var transformer = new _SystemImportExpressionTransformer2.default(state, params);
            var transformedExpression = transformer.createTransformedExpression();
            if (transformedExpression) {
              path.replaceWith(transformedExpression);
            }
          }
        }
      }
    }
  };
};

var _babelArgumentProvider = require('./babelArgumentProvider');

var _SystemImportExpressionTransformer = require('./SystemImportExpressionTransformer');

var _SystemImportExpressionTransformer2 = _interopRequireDefault(_SystemImportExpressionTransformer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }